<!--
Documentation for this component can be found at:
/docs/components/SessionToast.md
-->
<template>
  <div>
    <!-- Session Expired Overlay and Toast -->
    <b-overlay
      no-wrap
      variant="secondary"
      :fixed="true"
      :show="showOverlay"
      :opacity="0.9"
      :z-index="1000"
    >
      <template #overlay>
        <!-- Session Expired Toast -->
        <b-toast
          v-model="isSessionExpired"
          variant="warning"
          solid
          :auto-hide="false"
          no-close-button
          :title="$t('toast.sessionEnd.title')"
          class="bottom-left"
          body-class="rounded-bottom-custom"
        >
          <!-- Toast Body Text -->
          <p class="text-center">{{ $t("toast.sessionEnd.message") }}</p>

          <!-- Login Button -->
          <div class="d-flex justify-content-center">
            <b-button
              class="mt-2"
              size="sm"
              variant="primary"
              @click="redirectToLogin"
            >
              {{ $t("toast.sessionEnd.link") }}
            </b-button>
          </div>
        </b-toast>
      </template>
    </b-overlay>
  </div>
</template>

<script lang="ts">
import useLoginStore from "@/modules/login/store";
import { BToast, useToast } from "bootstrap-vue-next";
import { VNode } from "vue";
import { Translation } from "vue-i18n";

export default defineComponent({
  setup() {
    const loginStore = useLoginStore();
    const toastController = useToast();
    const i18n = useI18n();

    return { loginStore, toastController, i18n };
  },

  data() {
    return {
      showOverlay: false,
      isSessionExpired: false,
      showWarningToast: false,
      timeToExpiry: null as number | null,
      warningThreshold: 2 * 60 * 1000, // 2 minutes in milliseconds
      warningToast: undefined as symbol | undefined,

      warningTimeoutId: null as number | null,
      expirationTimeoutId: null as number | null,
    };
  },

  computed: {
    isLoggedIn(): boolean {
      return this.loginStore.isLoggedIn;
    },
    tokenExpirationTimestamp(): Date | null {
      return this.loginStore.authorization.expirationTimestamp.token;
    },
    cookieExpirationTimestamp(): Date | null {
      return this.loginStore.authorization.expirationTimestamp.cookie;
    },
  },

  watch: {
    // Watch for changes in the session
    isLoggedIn(newVal: boolean) {
      if (newVal) {
        // Session is active, reset timers
        this.isSessionExpired = false;
        this.showOverlay = false;
        this.setupSessionTimers();
      } else {
        // Session is expired
        this.clearTimers();
        this.isSessionExpired = true;
        this.showWarningToast = false;
        this.showOverlay = this.$route.meta.requiresAuth === true;
      }
    },

    // Watch for changes in the remaining session time for token expiration
    tokenExpirationTimestamp(newVal: Date | null, oldVal: Date | null) {
      if (newVal?.getTime() !== oldVal?.getTime()) {
        this.setupSessionTimers();
      }
    },

    // Watch for changes in the remaining session time for token expiration
    cookieExpirationTimestamp(newVal: Date | null, oldVal: Date | null) {
      if (newVal?.getTime() !== oldVal?.getTime()) {
        this.setupSessionTimers();
      }
    },

    showWarningToast(newVal) {
      // Show the warning toast when the flag is set to true and the session is not expired
      if (newVal === true) {
        this.removeWarningToast();
        this.createAndShowWarningToast();
      } else {
        this.removeWarningToast();
      }
    },
  },

  mounted() {
    this.setupSessionTimers();
  },

  unmounted() {
    this.removeWarningToast();
    this.clearTimers();
  },

  methods: {
    /**
     * Function to set up timers based on remaining session time
     */
    setupSessionTimers() {
      // Clear any existing timers
      this.clearTimers();

      const remainingTime = this.loginStore.calculateRemainingSessionTime();
      this.timeToExpiry = remainingTime;

      if (remainingTime !== null && remainingTime > 0) {
        // Calculate the time until the warning threshold is reached and show the warning toast
        const timeUntilWarning = remainingTime - this.warningThreshold;

        if (timeUntilWarning > 0) {
          // Set a timeout to show the warning toast
          this.warningTimeoutId = window.setTimeout(() => {
            this.showWarningToast = true;
          }, timeUntilWarning);
        } else {
          // If remaining time is less than the warning threshold, show the warning immediately
          this.showWarningToast = true;
        }

        // Set a timeout to handle session expiration
        this.expirationTimeoutId = window.setTimeout(() => {
          this.isSessionExpired = true;
          this.showOverlay = this.$route.name !== "login";
          this.showWarningToast = false; // Hide the warning toast when the session expires
        }, remainingTime);
      } else {
        // No remaining time means session is expired
        this.isSessionExpired = true;
        this.showOverlay = this.$route.name !== "login";
        this.showWarningToast = false; // Ensure the warning toast is hidden
      }
    },

    /**
     * Function to clear any existing timers
     */
    clearTimers() {
      if (this.warningTimeoutId !== null) {
        clearTimeout(this.warningTimeoutId);
        this.warningTimeoutId = null;
      }
      if (this.expirationTimeoutId !== null) {
        clearTimeout(this.expirationTimeoutId);
        this.expirationTimeoutId = null;
      }
      // Clear the warning toast when resetting timers (i.e., session extended)
      this.showWarningToast = false;
    },

    createAndShowWarningToast() {
      const toastComponent: VNode | undefined = h(BToast, null, {
        // Define the title slot content
        title: () =>
          h(Translation, {
            keypath: "toast.sessionWarning.title",
            tag: "span",
          }),

        // Define the default slot content (message)
        default: () =>
          h(Translation, {
            keypath: "toast.sessionWarning.message",
            tag: "span",
          }),
      });
      this.warningToast = this.toastController.show?.({
        props: {
          id: "session-warning-toast",
          pos: "bottom-end",
          noCloseButton: true,
          value: this.timeToExpiry ?? this.warningThreshold,
          noHoverPause: true,
          progressProps: {
            animated: true,
            variant: "info",
          },
        },
        component: toastComponent,
      });
    },

    removeWarningToast() {
      if (this.warningToast !== undefined) {
        this.toastController.remove?.(this.warningToast);
        this.warningToast = undefined;
      }
    },

    redirectToLogin() {
      // Redirect to login page
      this.$router.push({ name: "login" });
    },
  },
});
</script>
